import pack2                 # part-2 functions
from glob import glob        # filename expansion
from Tkinter import *        # gui widget stuff

class PackDialog(Toplevel):
    def __init__(self, target1, target2):
        Toplevel.__init__(self)                  # a new top-level window
        self.title('Enter Pack Parameters')      # 2 frames plus a button

        f1 = Frame(self) 
        f1.pack(anchor=N, expand=YES, fill=X)
        Label(f1, text='output file?', relief=RIDGE, width=15).pack(side=LEFT)
        e1 = Entry(f1, relief=SUNKEN) 
        e1.pack(side=RIGHT, expand=YES, fill=X)

        f2 = Frame(self)
        f2.pack(anchor=CENTER, expand=YES, fill=X)
        Label(f2, text='files to pack?', relief=RIDGE, width=15).pack(side=LEFT)
        e2 = Entry(f2, relief=SUNKEN) 
        e2.pack(side=RIGHT, expand=YES, fill=X)

        Button(self, text='OK', command=self.destroy).pack(anchor=S)
        e1['textvariable'] = target1
        e2['textvariable'] = target2

        self.grab_set()         # make myself modal:
        self.focus_set()        # mouse grab, keyboard focus, wait...
        self.wait_window()      # till destroy; else returns to caller now

def packDialog():
    s1, s2 = StringVar(), StringVar()          # run class like a function
    PackDialog(s1, s2)                         # pop-up dialog: sets s1/s2
    output, pattern = s1.get(), s2.get()       # whether 'ok' or wm-destroy
    print 'pack:', output, pattern
    pack2.pack_all(output, glob(pattern))      # should make output gui too

if __name__ == '__main__':
    class Outer(Frame):
        def __init__(self):
            Frame.__init__(self)
            self.pack()
            Button(self, text='pop', command=self.pop).pack()
            Button(self, text='hey', command=self.hey).pack()
        def pop(self): 
            packDialog()
        def hey(self): print 'HEY'      # make sure dialog is modal
    Outer().mainloop()
