import pack2                 # part-2 functions
from glob import glob        # filename expansion
from Tkinter import *        # gui widget stuff

class PackDialog(Toplevel):
    def __init__(self, target1, target2):
        Toplevel.__init__(self)                  # a new top-level window:
        self.minsize(1,1)                        # make it resizeable
        self.title('Enter Pack Parameters')      # 2 frames plus a button

        f1 = Frame(self, {Pack:{'anchor':'n', 'expand':1, 'fill':'x'}})
        Label(f1, {'text':'output file name?', 
                    Pack:{'side':'left'}, 'relief':'ridge', 'width':15 })
        self.e1 = Entry(f1, 
                     {'relief':'sunken', 
                      Pack:{'side':'right', 'expand':1, 'fill':'x'}})

        f2 = Frame(self, {Pack:{'anchor':'center', 'expand':1, 'fill':'x'}})
        Label(f2, {'text':'files to pack?', 
                    Pack:{'side':'left'}, 'relief':'ridge', 'width':15 })
        self.e2 = Entry(f2, 
                     {'relief':'sunken', 
                       Pack:{'side':'right', 'expand':1, 'fill':'x'}})

        Button(self, {'text':'OK', 'command':self.destroy, Pack:{'anchor':'s'}})

        self.e1['textvariable'] = target1
        self.e2['textvariable'] = target2

        self.grab_set()         # make myself modal:
        self.focus_set()        # mouse grab, keyboard focus, wait...
        self.wait_window()      # till destroy; else returns to caller now

def packDialog():
    s1, s2 = StringVar(), StringVar()          # run class like a function
    PackDialog(s1, s2)                         # pop-up dialog: sets s1/s2
    output, pattern = s1.get(), s2.get()       # whether 'ok' or wm-destroy
    print 'pack:', output, pattern
    pack2.pack_all(output, glob(pattern))      # should make output gui too...

if __name__ == '__main__':
    class Outer(Frame):
        def __init__(self):
            Frame.__init__(self)
            self.pack({})
            Button(self,{'text':'pop', 'command':self.pop, Pack:{}})
            Button(self,{'text':'hey', 'command':self.hey, Pack:{}})
        def pop(self): 
            packDialog()
        def hey(self): print 'HEY'      # make sure dialog is modal
    Outer().mainloop()
