import sys, string                      # get some built-in modules


class FakeStream:
    def close(self):			
        pass                         
    def flush(self):
        pass				


class Input(FakeStream):                 # a simulated input file
    def __init__(self, input):		
        self.text = input                

    def read(self, *size):
        if not size:
            res, self.text = self.text, ''
        else:
            res, self.text = self.text[:size[0]], self.text[size[0]:]
        return res

    def readline(self):
        eoln = string.find(self.text, '\n')
        if eoln == -1: 
            res, self.text = self.text, ''
        else:
            res, self.text = self.text[:eoln+1], self.text[eoln+1:]
        return res

    def readlines(self):
        res = []
        while 1:
            line = self.readline()
            if not line: break
            res.append(line)
        return res


class Output(FakeStream):                # a simulated output file
    def __init__(self):			         
        self.text = ''

    def write(self, string):
        self.text = self.text + string            

    def writelines(self, lines):
        for line in lines: self.write(line)


def redirect(input, function, args):            # redirect stdin/out
    save_stream = sys.stdin, sys.stdout         # run a function object 
    sys.stdin   = Input(input)                  # return stdout text
    sys.stdout  = Output()
    try:
        apply(function, args)
    except:
        sys.stderr.write('error in function! ')
        sys.stderr.write(`sys.exc_type` + ',' + `sys.exc_value` + '\n')
    result = sys.stdout.text
    sys.stdin, sys.stdout = save_stream
    return result
